#include<iostream>
#include "Header.h"
#include <time.h>
using namespace std;

/*
setzen obsahu zsobnku pomoc pole zsobnk
v zsobnku je N sel v rozsahu 1-M
pro kad islo z rozsahu je v poli jeden zsobnk
vytaen sla z hlavnho zsobnku jsou uloeny do zsobnk v poli
pot pedny zpt do hlavnho zsobnku ve sprvnm poad
*/

int main()
{
	Zasobnik* hlavnizasobnik=new Zasobnik();//hlavn zsobnk
	Zasobnik* polezasobniku;//pole zsobnk
	int N;
	int M;
	srand(time(NULL));

	//zadani N a M z klavesnice
	cout << "Zadej pocet cisel(N): " << endl;
	cin >> N;
	cout << "Zadej maximalni velikost: " << endl;
	cin >> M;

	polezasobniku = new Zasobnik[M]();//inicializace ukazatele na pole zasobniku

	for (int i = 0; i < N; i++)
		hlavnizasobnik->push(rand() % M + 1);//push nahodnych cisel v rozsahu od 1 do M

	cout << "Pred serazenim: "<< endl;//vypis obsahu zasobniku pred serazenim
	hlavnizasobnik->report();

	int vybraneCislo;

	while (!hlavnizasobnik->isEmpty())//vyprazdneni hlavniho zasobniku a roztrizeni prvku
	{
		hlavnizasobnik->pop(vybraneCislo);
		polezasobniku[vybraneCislo-1].push(vybraneCislo);//zasobniky maji indexy 0-(M-1) cisla jsou 1-M tedy odecteme jednicku
	}

	for (int i = 0; i < M; i++)//projdeme cele pole M zasobniku
	{
		while (!polezasobniku[i].isEmpty())//kazdy vypraznime
		{
			polezasobniku[i].pop(vybraneCislo);
			hlavnizasobnik->push(vybraneCislo);
		}
	}

	cout << "po serazeni: " << endl;
	hlavnizasobnik->report();

	delete[] polezasobniku;
	delete hlavnizasobnik;

	return 0;
}